import 'package:json_annotation/json_annotation.dart';

import 'IR5Address.dart' show IR5Address;

part 'IR5Etab.g.dart';

// --------------------------------------------------------------------------------
enum SrvcState { SvcUndefined, SvcOpenEmpty, SvcOpen, SvcClosing, SvcClosed }
const Map<int, SrvcState> SrvcStates = {
  0: SrvcState.SvcUndefined,
  1: SrvcState.SvcOpenEmpty,
  2: SrvcState.SvcOpen,
  3: SrvcState.SvcClosing,
  4: SrvcState.SvcClosed,
};
int SrvcStateToJson(SrvcState f) {
  return SrvcStates.entries.firstWhere((element) => element.value == f).key;
}

// --------------------------------------------------------------------------------
enum PayRounding { ExactPay, RoundTo5Cents, dotBERounding, dotBEOnlyCash }
const Map<int, PayRounding> PayRoundings = {
  0: PayRounding.ExactPay,
  1: PayRounding.RoundTo5Cents,
  2: PayRounding.dotBERounding,
  3: PayRounding.dotBEOnlyCash,
};
int PayRoundingToJson(PayRounding f) {
  return PayRoundings.entries.firstWhere((element) => element.value == f).key;
}
// --------------------------------------------------------------------------------

/** Etab aka Restaurant */
@JsonSerializable(explicitToJson: true)
class IR5Etab {
  const IR5Etab({
    required this.FDMMode,
    required this.FDMInfo,
    required this.FDMVerInfo,
    required this.FDMApprovalNumber,
    required this.CMAXNum,
    required this.Nom,
    required this.CompanyName,
    required this.HeadOffice,
    required this.Address,
    required this.TVA,
    required this.SIRET,
    required this.DEV0,
    required this.DateService,
    required this.NoService,
    required this.NomService,
    required this.ServiceStatus,
    required this.ServiceInfo,
    required this.ModeTVA,
    required this.TauxTVA1,
    required this.TauxTVA2,
    required this.TauxTVA3,
    required this.PayRounding,
    required this.Flags_Etab,
    required this.Flags_Station,
    required this.Flags_Staff,
    required this.Flags_Caisse,
    required this.Flags_Cloture,
    required this.Flags_Modules,
    required this.Flags_Members,
    required this.Flags_Stock,
    required this.AddLogo,
    required this.Reg,
    required this.LockPrice,
    required this.ForceRecalc,
    required this.TaxExNoRecalc,
    required this.PlanSalleRuntimeDesign,
    required this.RestomaxLongClick,
    required this.AlwaysShowQtOnTicket,
    required this.OLAPExportHistoDeleteAllowed,
    required this.OLAPArchiveHistoDeleteAllowed,
    required this.ShowAvgs,
    required this.ShowCvts,
    required this.ShowQty,
    required this.ShowPercent,
    required this.ShowTHOUSANDSEPARATOR,
    required this.ShowKILO,
    required this.TicketNumByRoute,
    required this.TicketNumByPtr,
    required this.TicketNumCdes,
    required this.TicketNumSeqs,
    required this.RptNumXZ,
    required this.Reserved,
    required this.FStaffNISSCtrl,
    required this.ForceTariffNormal,
    required this.ForceTariffHappyHour,
    required this.AutoHappyHour,
    required this.ShortHold,
    required this.LogOffAfterShortHold,
    required this.LongHold,
    required this.LogOffAfterLongHold,
    required this.HoldTakeStock,
    required this.LogTblHold,
    required this.DiscountLimited,
    required this.TableBloqueGarcon,
    required this.AdditionBloqueGarcon,
    required this.CashBloqueGarcon,
    required this.ShowErrLine,
    required this.LimitModeInOut,
    required this.KeepErrLine,
    required this.ModeTraining,
    required this.AuthJustification,
    required this.AuthByAllowed,
    required this.NoCumulSalesRefund,
    required this.FullTicketMsg,
    required this.DoNumSeq,
    required this.NumSeqRestart,
    required this.DontNumSales,
    required this.NumSalesAtOuverture,
    required this.NumSalesAtAddition,
    required this.NumSalesAtCloture,
    required this.NumSalesRestart,
    required this.BISOrderByCategorie,
    required this.BISNoExternalPLUs,
    required this.BISShowZero,
    required this.BISAutoReload,
    required this.BISNoColor,
    required this.LancerBeforeEnCaisse,
    required this.CashDrawerMsg,
    required this.TicketSimple,
    required this.OnlyOneTicketSimple,
    required this.LogTicketSimple,
    required this.NoAddition,
    required this.NoAdditionIffInvoice,
    required this.LancerBeforeAddition,
    required this.AdditionBrute,
    required this.AdditionBySsAdd,
    required this.ShowForfaitOnAdd,
    required this.ShowDetailsMenuOnAdd,
    required this.AdditionByCateg,
    required this.AdditionDotBE,
    required this.AdditionGlobale,
    required this.AdditionBySeq,
    required this.AdditionBySep,
    required this.LogAdditionDupl,
    required this.CheckVATSalesRefund,
    required this.OuvSrvcAuto,
    required this.OuvSrvcForceDate,
    required this.OpenServiceFDMStartForced,
    required this.ClotureAuto,
    required this.ClotureAutoDayZero,
    required this.ClotureAutoWithOpenTbls,
    required this.ClotureAutoTblsBlanco,
    required this.ClotureAutoKeepTbls,
    required this.ClotureAutoTbls,
    required this.ClotureKeepTbls,
    required this.ClotureWithOpenTbls,
    required this.ClotureTblsBlanco,
    required this.ClotureWithOpenStaffs,
    required this.DeleteHisto,
    required this.ArchiveHisto,
    required this.ClotureTbls,
    required this.Archive2Cloud,
    required this.ConsolideBarControl,
    required this.KeepHistoDays,
    required this.ClotureAutoPrintRptZ,
    required this.ClotureAutoMailRptZ,
    required this.CloturePrintRptZ,
    required this.ClotureMailRptZ,
    required this.ClotureForceShutdown,
    required this.ClotureShowShutdown,
    required this.AllwaysShowCloture,
    required this.RAZPlanSalle,
    required this.KeepNoTable,
    required this.RptOuvStaff,
    required this.StaffCloture,
    required this.RptClotStaff,
    required this.FullDailyBackup2Cloud,
    required this.FullMonthlyBackup2Cloud,
    required this.OnlyDataDailyBackup2Cloud,
    required this.OnlyDataMonthlyBackup2Cloud,
    required this.SaveNumZTot,
    required this.Member,
    required this.ModuleStock,
    required this.FreeVoucherModule,
    required this.HotelLnk,
    required this.HotSpotCodes,
    required this.PayHotelHTNG,
    required this.GantnerReader,
    required this.FingerPrintReader,
    required this.SmartCardReader,
    required this.RestoPass,
    required this.PayCortess,
    required this.HappyHour,
    required this.Balance,
    required this.Evenement,
    required this.Reservation,
    required this.BadgeReader,
    required this.BarCodeReader,
    required this.CustomerDisplay,
    required this.AccLink,
    required this.Telemax,
    required this.SEPAFile,
    required this.ExternalPLUsLnk,
    required this.ModuleRptParGarcon,
    required this.DontSignClockIN,
    required this.NeedClockIN,
    required this.ModulePrestation,
    required this.ClockINout,
    required this.AutoClockINout,
    required this.BarControlLog2File,
    required this.BarControl,
    required this.BarControlByStation,
    required this.BarControlIgNoreNegatif,
    required this.BankTerminals,
    required this.CashMachines,
    required this.CptesClient,
    required this.AutoPrintNewMember,
    required this.FactDNeedVATNr,
    required this.MemberTariff,
    required this.DirectDiscount,
    required this.GlobalDiscount,
    required this.SoloCloture,
    required this.MonthlyClotureWithReport,
    required this.MonthlyClotureWithRAZ,
    required this.MonthlyFact,
    required this.FactDirect,
    required this.FactDirectAllowTicket,
    required this.FactDirectAllowPrint,
    required this.FactDirectAllowMail,
    required this.FactDirectAllowNoDetails,
    required this.FactDeferred,
    required this.FactDDLog,
    required this.LogRePrintInvTicket,
    required this.SoloClotureAutoAfterPtr,
    required this.SoloClotureAutoAfterPtrAsk,
    required this.SoloClotureAutoAfterRecharge,
    required this.SoloClotureAutoAfterRechargeRAZ,
    required this.ForceSaveHisto,
    required this.NoFidelityPointsIfDiscount,
    required this.TokenPay,
    required this.AutoFreeVoucher,
    required this.UseFreeVoucher,
    required this.FreeVoucherCheckTotalTbl,
    required this.FreeVoucherCheckClient,
    required this.MakeFreeVoucherAuto,
    required this.DoNotPrintFreeVoucherAuto,
    required this.FreeVoucherTruncToTotalTbl,
    required this.FreeVoucherCheckCMAXNum,
    required this.RptShowTVAVentil,
    required this.FullNameAsPrenomNom,
    required this.FullNameAsOnlyNom,
    required this.HasBlocageAuto,
    required this.PassThroughBlocageManual,
    required this.PassThroughBlocageAuto,
    required this.LogBlocageManual,
    required this.LogBlocageAuto,
    required this.StockManagement,
    required this.KeepVente,
    required this.KeepAchat,
    required this.AskCostPrice,
    required this.AskAchatDesc,
  });

  factory IR5Etab.fromJson([Map<String, dynamic>? json]) =>
      _$IR5EtabFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5EtabToJson(this);

  /** Fiscal Data Module
    * X:NoFDMMode
    * D:DebugMode (internal Restomax mode)
    * b:BelgiumMode Demo
    * B:BelgiumMode
    */
  @JsonKey(defaultValue: '')
  final String FDMMode;
  @JsonKey(defaultValue: '')
  final String FDMInfo;
  @JsonKey(defaultValue: '')
  final String FDMVerInfo;
  @JsonKey(defaultValue: '')
  final String FDMApprovalNumber;
  /** Internal Restomax Unique Customer Number */
  @JsonKey(defaultValue: '')
  final String CMAXNum;
  /** Just a Name */
  @JsonKey(defaultValue: '')
  final String Nom;
  @JsonKey(defaultValue: '')
  final String CompanyName;
  @JsonKey(defaultValue: '')
  final String HeadOffice;
  final IR5Address Address;
  @JsonKey(defaultValue: '')
  final String TVA;
  @JsonKey(defaultValue: '')
  final String SIRET;
  /** Currency Id ex:EUR */
  @JsonKey(defaultValue: '')
  final String DEV0;
  /** Service Date */
  @JsonKey(defaultValue: '')
  final String DateService;
  /** Service Number */
  @JsonKey(defaultValue: 0)
  final int NoService;
  /** Just a Name */
  @JsonKey(defaultValue: '')
  final String NomService;
  /** Service Status
    *     csNoSrvc = 0
    *     csSrvcOuvertNonUtilise = 1
    *     csSrvcOuvertUtilise = 2
    *     csSrvcClotureEnCours = 3
    *     csSrvcCloture = 4
    */
  @JsonKey(defaultValue: 0)
  final int /* Number | SrvcState */ ServiceStatus;
  @JsonKey(defaultValue: '')
  final String ServiceInfo;
  /** VAT Mode
    * vatModeRestomax,
    * vatModePOS
    */
  @JsonKey(defaultValue: '')
  final String ModeTVA;
  /** VAT Rate 1 = 6% */
  @JsonKey(defaultValue: 6)
  final num TauxTVA1;
  /** VAT Rate 2 = 12% */
  @JsonKey(defaultValue: 12)
  final num TauxTVA2;
  /** VAT Rate 3 = 21% */
  @JsonKey(defaultValue: 21)
  final num TauxTVA3;
  @JsonKey(defaultValue: 0)
  final int /* Number | PayRounding */ PayRounding;
  /** Etab Flags
    *   Bit 10 : LockPrice
    *   Bit 11 : ForceRecalc
    *   Bit 12 : TaxExNoRecalc
    *   Bit 15 : RoundTo05Cents
    *   Bit 16 : DotBERounding
    *   Bit 17 : DotBEOnlyCash
    *   Bit 20 : PlanSalleRuntimeDesign
    *   Bit 21 : RestomaxLongClick
    *   Bit 30 : AlwaysShowQtOnTicket
    *   Bit 40 : OLAPExportHistoDeleteAllowed
    *   Bit 41 : OLAPArchiveHistoDeleteAllowed
    *   Bit 46 : ShowAvgs
    *   Bit 47 : ShowCvts
    *   Bit 48 : ShowQty
    *   Bit 49 : ShowPercent
    *   Bit 50 : ShowTHOUSANDSEPARATOR
    *   Bit 51 : ShowKILO
    *   Bit 56 : TicketNumByRoute
    *   Bit 57 : TicketNumByPtr
    *   Bit 58 : TicketNumCdes
    *   Bit 59 : TicketNumSeqs
    *   Bit 60 : RptNumXZ
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Etab;
  /** Etab StationCtrl Flags
    *   Bit 00 : Reserved
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Station;
  /** Etab StaffCtrl Flags
    *   Bit 10 : fStaffNISSCtrl
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Staff;
  /** Etab Pointage Flags
    *   Bit 00 : ForceTariffNormal
    *   Bit 01 : ForceTariffHappyHour
    *   Bit 02 : AutoHappyHour
    *   Bit 03 : ShortHold
    *   Bit 04 : LogOffAfterShortHold
    *   Bit 05 : LongHold
    *   Bit 06 : LogOffAfterLongHold
    *   Bit 07 : HoldTakeStock
    *   Bit 08 : LogTblHold
    *   Bit 10 : DiscountLimited
    *   Bit 11 : TableBloqueGarcon
    *   Bit 12 : AdditionBloqueGarcon
    *   Bit 13 : CashBloqueGarcon
    *   Bit 16 : ShowErrLine
    *   Bit 17 : LimitModeInOut
    *   Bit 18 : KeepErrLine
    *   Bit 19 : ModeTraining
    *   Bit 20 : AuthJustification
    *   Bit 21 : AuthByAllowed
    *   Bit 22 : NoCumulSalesRefund
    *   Bit 23 : FullTicketMsg
    *   Bit 26 : DoNumSeq
    *   Bit 27 : NumSeqRestart
    *   Bit 29 : DontNumSales
    *   Bit 30 : NumSalesAtOuverture
    *   Bit 31 : NumSalesAtAddition
    *   Bit 32 : NumSalesAtCloture
    *   Bit 33 : NumSalesRestart
    *   Bit 36 : BISOrderByCategorie
    *   Bit 37 : BISNoExternalPLUs
    *   Bit 38 : BISShowZero
    *   Bit 39 : BISAutoReload
    *   Bit 40 : BISNoColor
    *   Bit 43 : LancerBeforeEnCaisse
    *   Bit 44 : CashDrawerMsg
    *   Bit 45 : TicketSimple
    *   Bit 46 : OnlyOneTicketSimple
    *   Bit 47 : LogTicketSimple
    *   Bit 48 : NoAddition
    *   Bit 49 : NoAdditionIffInvoice
    *   Bit 50 : LancerBeforeAddition
    *   Bit 51 : AdditionBrute
    *   Bit 52 : AdditionBySsAdd
    *   Bit 53 : ShowForfaitOnAdd
    *   Bit 54 : ShowDetailsMenuOnAdd
    *   Bit 55 : AdditionByCateg
    *   Bit 58 : AdditionDotBE
    *   Bit 59 : AdditionGlobale
    *   Bit 60 : AdditionBySeq
    *   Bit 61 : AdditionBySep
    *   Bit 62 : LogAdditionDupl
    *   Bit 63 : CheckVATSalesRefund
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Caisse;
  /** Etab Cloture Flags
    *   Bit 00 : OuvSrvcAuto
    *   Bit 01 : OuvSrvcForceDate
    *   Bit 06 : OpenService_FDMStartForced
    *   Bit 10 : ClotureAuto
    *   Bit 11 : ClotureAutoDayZero
    *   Bit 13 : ClotureAutoWithOpenTbls
    *   Bit 14 : ClotureAutoTblsBlanco
    *   Bit 15 : ClotureAutoKeepTbls
    *   Bit 16 : ClotureAutoTbls
    *   Bit 17 : ClotureKeepTbls
    *   Bit 18 : ClotureWithOpenTbls
    *   Bit 19 : ClotureTblsBlanco
    *   Bit 20 : ClotureWithOpenStaffs
    *   Bit 21 : DeleteHisto
    *   Bit 22 : ArchiveHisto
    *   Bit 23 : ClotureTbls
    *   Bit 24 : Archive2Cloud
    *   Bit 25 : ConsolideBarControl
    *   Bit 26 : KeepHistoDays
    *   Bit 28 : ClotureAutoPrintRptZ
    *   Bit 29 : ClotureAutoMailRptZ
    *   Bit 33 : CloturePrintRptZ
    *   Bit 34 : ClotureMailRptZ
    *   Bit 36 : ClotureForceShutdown
    *   Bit 37 : ClotureShowShutdown
    *   Bit 38 : AllwaysShowCloture
    *   Bit 39 : RAZPlanSalle
    *   Bit 40 : KeepNoTable
    *   Bit 47 : RptOuvStaff
    *   Bit 50 : StaffCloture
    *   Bit 51 : RptClotStaff
    *   Bit 54 : FullDailyBackup2Cloud
    *   Bit 55 : FullMonthlyBackup2Cloud
    *   Bit 56 : OnlyDataDailyBackup2Cloud
    *   Bit 57 : OnlyDataMonthlyBackup2Cloud
    *   Bit 59 : SaveNumZTot
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Cloture;
  /** Etab Modules Flags
    *   Bit 00 : Member
    *   Bit 07 : ModuleStock
    *   Bit 12 : RptClockInOut
    *   Bit 16 : PayJetonModule
    *   Bit 21 : FreeVoucherModule
    *   Bit 27 : HotelLnk
    *   Bit 30 : HotSpotCodes
    *   Bit 31 : PayHotelHTNG
    *   Bit 32 : GantnerReader
    *   Bit 33 : FingerPrintReader
    *   Bit 34 : SmartCardReader
    *   Bit 35 : RestoPass
    *   Bit 36 : PayCortess
    *   Bit 38 : HappyHour
    *   Bit 39 : Balance
    *   Bit 40 : Evenement
    *   Bit 41 : Reservation
    *   Bit 42 : BadgeReader
    *   Bit 43 : BarCodeReader
    *   Bit 44 : CustomerDisplay
    *   Bit 45 : AccLink
    *   Bit 46 : Telemax
    *   Bit 47 : SEPAFile
    *   Bit 49 : ExternalPLUsLnk
    *   Bit 50 : ModuleRptParGarcon
    *   Bit 51 : DontSignClockIN
    *   Bit 52 : NeedClockIN
    *   Bit 53 : ModulePrestation
    *   Bit 54 : ClockINout
    *   Bit 55 : AutoClockINout
    *   Bit 56 : BarControlLog2File
    *   Bit 57 : BarControl
    *   Bit 58 : BarControlByStation
    *   Bit 59 : BarControlIgNoreNegatif
    *   Bit 60 : BankTerminals
    *   Bit 63 : CashMachines
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Modules;
  /** Etab Stock Flags
    *   Bit 00 : CptesClient
    *   Bit 01 : AutoPrintNewMember
    *   Bit 02 : FactDNeedVATNr
    *   Bit 04 : MemberTariff
    *   Bit 05 : DirectDiscount
    *   Bit 06 : GlobalDiscount
    *   Bit 10 : SoloCloture
    *   Bit 12 : MonthlyClotureWithReport
    *   Bit 14 : MonthlyClotureWithRAZ
    *   Bit 19 : MonthlyFact
    *   Bit 20 : FactDirect
    *   Bit 21 : FactDirectAllowTicket
    *   Bit 22 : FactDirectAllowPrint
    *   Bit 23 : FactDirectAllowMail
    *   Bit 24 : FactDirectAllowNoDetails
    *   Bit 27 : FactDeferred
    *   Bit 28 : FactDDLog
    *   Bit 29 : LogRePrintInvTicket
    *   Bit 30 : SoloClotureAutoAfterPtr
    *   Bit 31 : SoloClotureAutoAfterPtrAsk
    *   Bit 35 : SoloClotureAutoAfterRecharge
    *   Bit 36 : SoloClotureAutoAfterRechargeRAZ
    *   Bit 40 : ForceSaveHisto
    *   Bit 43 : NoFidelityPointsIfDiscount
    *   Bit 51 : AutoFreeVoucher
    *   Bit 52 : UseFreeVoucher
    *   Bit 53 : FreeVoucherCheckTotalTbl
    *   Bit 54 : FreeVoucherCheckClient
    *   Bit 55 : MakeFreeVoucherAuto
    *   Bit 56 : DoNotPrintFreeVoucherAuto
    *   Bit 57 : FreeVoucherTruncToTotalTbl
    *   Bit 58 : FreeVoucherCheckCMAXNum
    *   Bit 60 : RptShowTVAVentil
    *   Bit 61 : FullNameAsPrenomNom
    *   Bit 62 : FullNameAsOnlyNom
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Members;
  /** Etab Stock Flags
    *   Bit 20 : HasBlocageAuto
    *   Bit 21 : PassThroughBlocageManual
    *   Bit 22 : PassThroughBlocageAuto
    *   Bit 23 : LogBlocageManual
    *   Bit 24 : LogBlocageAuto
    *   Bit 40 : StockManagement
    *   Bit 41 : KeepVente
    *   Bit 42 : KeepAchat
    *   Bit 51 : AskCostPrice
    *   Bit 52 : AskAchatDesc
    */
  @JsonKey(defaultValue: 0)
  final int Flags_Stock;
  /** Logo to be printed on Addition Ticket */
  @JsonKey(defaultValue: 0)
  final int AddLogo;
  /** Registry values */
  @JsonKey(defaultValue: {})
  final dynamic Reg;

  @JsonKey(defaultValue: false)
  final bool LockPrice;
  @JsonKey(defaultValue: false)
  final bool ForceRecalc;
  @JsonKey(defaultValue: false)
  final bool TaxExNoRecalc;
  @JsonKey(defaultValue: false)
  final bool PlanSalleRuntimeDesign;
  @JsonKey(defaultValue: false)
  final bool RestomaxLongClick;
  @JsonKey(defaultValue: false)
  final bool AlwaysShowQtOnTicket;
  @JsonKey(defaultValue: false)
  final bool OLAPExportHistoDeleteAllowed;
  @JsonKey(defaultValue: false)
  final bool OLAPArchiveHistoDeleteAllowed;
  @JsonKey(defaultValue: false)
  final bool ShowAvgs;
  @JsonKey(defaultValue: false)
  final bool ShowCvts;
  @JsonKey(defaultValue: false)
  final bool ShowQty;
  @JsonKey(defaultValue: false)
  final bool ShowPercent;
  @JsonKey(defaultValue: false)
  final bool ShowTHOUSANDSEPARATOR;
  @JsonKey(defaultValue: false)
  final bool ShowKILO;
  @JsonKey(defaultValue: false)
  final bool TicketNumByRoute;
  @JsonKey(defaultValue: false)
  final bool TicketNumByPtr;
  @JsonKey(defaultValue: false)
  final bool TicketNumCdes;
  @JsonKey(defaultValue: false)
  final bool TicketNumSeqs;
  @JsonKey(defaultValue: false)
  final bool RptNumXZ;
  @JsonKey(defaultValue: false)
  final bool Reserved;
  @JsonKey(defaultValue: false)
  final bool FStaffNISSCtrl;
  @JsonKey(defaultValue: false)
  final bool ForceTariffNormal;
  @JsonKey(defaultValue: false)
  final bool ForceTariffHappyHour;
  @JsonKey(defaultValue: false)
  final bool AutoHappyHour;
  @JsonKey(defaultValue: false)
  final bool ShortHold;
  @JsonKey(defaultValue: false)
  final bool LogOffAfterShortHold;
  @JsonKey(defaultValue: false)
  final bool LongHold;
  @JsonKey(defaultValue: false)
  final bool LogOffAfterLongHold;
  @JsonKey(defaultValue: false)
  final bool HoldTakeStock;
  @JsonKey(defaultValue: false)
  final bool LogTblHold;
  @JsonKey(defaultValue: false)
  final bool DiscountLimited;
  @JsonKey(defaultValue: false)
  final bool TableBloqueGarcon;
  @JsonKey(defaultValue: false)
  final bool AdditionBloqueGarcon;
  @JsonKey(defaultValue: false)
  final bool CashBloqueGarcon;
  @JsonKey(defaultValue: false)
  final bool ShowErrLine;
  @JsonKey(defaultValue: false)
  final bool LimitModeInOut;
  @JsonKey(defaultValue: false)
  final bool KeepErrLine;
  @JsonKey(defaultValue: false)
  final bool ModeTraining;
  @JsonKey(defaultValue: false)
  final bool AuthJustification;
  @JsonKey(defaultValue: false)
  final bool AuthByAllowed;
  @JsonKey(defaultValue: false)
  final bool NoCumulSalesRefund;
  @JsonKey(defaultValue: false)
  final bool FullTicketMsg;
  @JsonKey(defaultValue: false)
  final bool DoNumSeq;
  @JsonKey(defaultValue: false)
  final bool NumSeqRestart;
  @JsonKey(defaultValue: false)
  final bool DontNumSales;
  @JsonKey(defaultValue: false)
  final bool NumSalesAtOuverture;
  @JsonKey(defaultValue: false)
  final bool NumSalesAtAddition;
  @JsonKey(defaultValue: false)
  final bool NumSalesAtCloture;
  @JsonKey(defaultValue: false)
  final bool NumSalesRestart;
  @JsonKey(defaultValue: false)
  final bool BISOrderByCategorie;
  @JsonKey(defaultValue: false)
  final bool BISNoExternalPLUs;
  @JsonKey(defaultValue: false)
  final bool BISShowZero;
  @JsonKey(defaultValue: false)
  final bool BISAutoReload;
  @JsonKey(defaultValue: false)
  final bool BISNoColor;
  @JsonKey(defaultValue: false)
  final bool LancerBeforeEnCaisse;
  @JsonKey(defaultValue: false)
  final bool CashDrawerMsg;
  @JsonKey(defaultValue: false)
  final bool TicketSimple;
  @JsonKey(defaultValue: false)
  final bool OnlyOneTicketSimple;
  @JsonKey(defaultValue: false)
  final bool LogTicketSimple;
  @JsonKey(defaultValue: false)
  final bool NoAddition;
  @JsonKey(defaultValue: false)
  final bool NoAdditionIffInvoice;
  @JsonKey(defaultValue: false)
  final bool LancerBeforeAddition;
  @JsonKey(defaultValue: false)
  final bool AdditionBrute;
  @JsonKey(defaultValue: false)
  final bool AdditionBySsAdd;
  @JsonKey(defaultValue: false)
  final bool ShowForfaitOnAdd;
  @JsonKey(defaultValue: false)
  final bool ShowDetailsMenuOnAdd;
  @JsonKey(defaultValue: false)
  final bool AdditionByCateg;
  @JsonKey(defaultValue: false)
  final bool AdditionDotBE;
  @JsonKey(defaultValue: false)
  final bool AdditionGlobale;
  @JsonKey(defaultValue: false)
  final bool AdditionBySeq;
  @JsonKey(defaultValue: false)
  final bool AdditionBySep;
  @JsonKey(defaultValue: false)
  final bool LogAdditionDupl;
  @JsonKey(defaultValue: false)
  final bool CheckVATSalesRefund;
  @JsonKey(defaultValue: false)
  final bool OuvSrvcAuto;
  @JsonKey(defaultValue: false)
  final bool OuvSrvcForceDate;
  @JsonKey(defaultValue: false)
  final bool OpenServiceFDMStartForced;
  @JsonKey(defaultValue: false)
  final bool ClotureAuto;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoDayZero;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoWithOpenTbls;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoTblsBlanco;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoKeepTbls;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoTbls;
  @JsonKey(defaultValue: false)
  final bool ClotureKeepTbls;
  @JsonKey(defaultValue: false)
  final bool ClotureWithOpenTbls;
  @JsonKey(defaultValue: false)
  final bool ClotureTblsBlanco;
  @JsonKey(defaultValue: false)
  final bool ClotureWithOpenStaffs;
  @JsonKey(defaultValue: false)
  final bool DeleteHisto;
  @JsonKey(defaultValue: false)
  final bool ArchiveHisto;
  @JsonKey(defaultValue: false)
  final bool ClotureTbls;
  @JsonKey(defaultValue: false)
  final bool Archive2Cloud;
  @JsonKey(defaultValue: false)
  final bool ConsolideBarControl;
  @JsonKey(defaultValue: false)
  final bool KeepHistoDays;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoPrintRptZ;
  @JsonKey(defaultValue: false)
  final bool ClotureAutoMailRptZ;
  @JsonKey(defaultValue: false)
  final bool CloturePrintRptZ;
  @JsonKey(defaultValue: false)
  final bool ClotureMailRptZ;
  @JsonKey(defaultValue: false)
  final bool ClotureForceShutdown;
  @JsonKey(defaultValue: false)
  final bool ClotureShowShutdown;
  @JsonKey(defaultValue: false)
  final bool AllwaysShowCloture;
  @JsonKey(defaultValue: false)
  final bool RAZPlanSalle;
  @JsonKey(defaultValue: false)
  final bool KeepNoTable;
  @JsonKey(defaultValue: false)
  final bool RptOuvStaff;
  @JsonKey(defaultValue: false)
  final bool StaffCloture;
  @JsonKey(defaultValue: false)
  final bool RptClotStaff;
  @JsonKey(defaultValue: false)
  final bool FullDailyBackup2Cloud;
  @JsonKey(defaultValue: false)
  final bool FullMonthlyBackup2Cloud;
  @JsonKey(defaultValue: false)
  final bool OnlyDataDailyBackup2Cloud;
  @JsonKey(defaultValue: false)
  final bool OnlyDataMonthlyBackup2Cloud;
  @JsonKey(defaultValue: false)
  final bool SaveNumZTot;
  @JsonKey(defaultValue: false)
  final bool Member;
  @JsonKey(defaultValue: false)
  final bool ModuleStock;
  @JsonKey(defaultValue: false)
  final bool FreeVoucherModule;
  @JsonKey(defaultValue: false)
  final bool HotelLnk;
  @JsonKey(defaultValue: false)
  final bool HotSpotCodes;
  @JsonKey(defaultValue: false)
  final bool PayHotelHTNG;
  @JsonKey(defaultValue: false)
  final bool GantnerReader;
  @JsonKey(defaultValue: false)
  final bool FingerPrintReader;
  @JsonKey(defaultValue: false)
  final bool SmartCardReader;
  @JsonKey(defaultValue: false)
  final bool RestoPass;
  @JsonKey(defaultValue: false)
  final bool PayCortess;
  @JsonKey(defaultValue: false)
  final bool HappyHour;
  @JsonKey(defaultValue: false)
  final bool Balance;
  @JsonKey(defaultValue: false)
  final bool Evenement;
  @JsonKey(defaultValue: false)
  final bool Reservation;
  @JsonKey(defaultValue: false)
  final bool BadgeReader;
  @JsonKey(defaultValue: false)
  final bool BarCodeReader;
  @JsonKey(defaultValue: false)
  final bool CustomerDisplay;
  @JsonKey(defaultValue: false)
  final bool AccLink;
  @JsonKey(defaultValue: false)
  final bool Telemax;
  @JsonKey(defaultValue: false)
  final bool SEPAFile;
  @JsonKey(defaultValue: false)
  final bool ExternalPLUsLnk;
  @JsonKey(defaultValue: false)
  final bool ModuleRptParGarcon;
  @JsonKey(defaultValue: false)
  final bool DontSignClockIN;
  @JsonKey(defaultValue: false)
  final bool NeedClockIN;
  @JsonKey(defaultValue: false)
  final bool ModulePrestation;
  @JsonKey(defaultValue: false)
  final bool ClockINout;
  @JsonKey(defaultValue: false)
  final bool AutoClockINout;
  @JsonKey(defaultValue: false)
  final bool BarControlLog2File;
  @JsonKey(defaultValue: false)
  final bool BarControl;
  @JsonKey(defaultValue: false)
  final bool BarControlByStation;
  @JsonKey(defaultValue: false)
  final bool BarControlIgNoreNegatif;
  @JsonKey(defaultValue: false)
  final bool BankTerminals;
  @JsonKey(defaultValue: false)
  final bool CashMachines;
  @JsonKey(defaultValue: false)
  final bool CptesClient;
  @JsonKey(defaultValue: false)
  final bool AutoPrintNewMember;
  @JsonKey(defaultValue: false)
  final bool FactDNeedVATNr;
  @JsonKey(defaultValue: false)
  final bool MemberTariff;
  @JsonKey(defaultValue: false)
  final bool DirectDiscount;
  @JsonKey(defaultValue: false)
  final bool GlobalDiscount;
  @JsonKey(defaultValue: false)
  final bool SoloCloture;
  @JsonKey(defaultValue: false)
  final bool MonthlyClotureWithReport;
  @JsonKey(defaultValue: false)
  final bool MonthlyClotureWithRAZ;
  @JsonKey(defaultValue: false)
  final bool MonthlyFact;
  @JsonKey(defaultValue: false)
  final bool FactDirect;
  @JsonKey(defaultValue: false)
  final bool FactDirectAllowTicket;
  @JsonKey(defaultValue: false)
  final bool FactDirectAllowPrint;
  @JsonKey(defaultValue: false)
  final bool FactDirectAllowMail;
  @JsonKey(defaultValue: false)
  final bool FactDirectAllowNoDetails;
  @JsonKey(defaultValue: false)
  final bool FactDeferred;
  @JsonKey(defaultValue: false)
  final bool FactDDLog;
  @JsonKey(defaultValue: false)
  final bool LogRePrintInvTicket;
  @JsonKey(defaultValue: false)
  final bool SoloClotureAutoAfterPtr;
  @JsonKey(defaultValue: false)
  final bool SoloClotureAutoAfterPtrAsk;
  @JsonKey(defaultValue: false)
  final bool SoloClotureAutoAfterRecharge;
  @JsonKey(defaultValue: false)
  final bool SoloClotureAutoAfterRechargeRAZ;
  @JsonKey(defaultValue: false)
  final bool ForceSaveHisto;
  @JsonKey(defaultValue: false)
  final bool NoFidelityPointsIfDiscount;
  @JsonKey(defaultValue: false)
  final bool TokenPay;
  @JsonKey(defaultValue: false)
  final bool AutoFreeVoucher;
  @JsonKey(defaultValue: false)
  final bool UseFreeVoucher;
  @JsonKey(defaultValue: false)
  final bool FreeVoucherCheckTotalTbl;
  @JsonKey(defaultValue: false)
  final bool FreeVoucherCheckClient;
  @JsonKey(defaultValue: false)
  final bool MakeFreeVoucherAuto;
  @JsonKey(defaultValue: false)
  final bool DoNotPrintFreeVoucherAuto;
  @JsonKey(defaultValue: false)
  final bool FreeVoucherTruncToTotalTbl;
  @JsonKey(defaultValue: false)
  final bool FreeVoucherCheckCMAXNum;
  @JsonKey(defaultValue: false)
  final bool RptShowTVAVentil;
  @JsonKey(defaultValue: false)
  final bool FullNameAsPrenomNom;
  @JsonKey(defaultValue: false)
  final bool FullNameAsOnlyNom;
  @JsonKey(defaultValue: false)
  final bool HasBlocageAuto;
  @JsonKey(defaultValue: false)
  final bool PassThroughBlocageManual;
  @JsonKey(defaultValue: false)
  final bool PassThroughBlocageAuto;
  @JsonKey(defaultValue: false)
  final bool LogBlocageManual;
  @JsonKey(defaultValue: false)
  final bool LogBlocageAuto;
  @JsonKey(defaultValue: false)
  final bool StockManagement;
  @JsonKey(defaultValue: false)
  final bool KeepVente;
  @JsonKey(defaultValue: false)
  final bool KeepAchat;
  @JsonKey(defaultValue: false)
  final bool AskCostPrice;
  @JsonKey(defaultValue: false)
  final bool AskAchatDesc;
}
