import 'package:json_annotation/json_annotation.dart';

import 'IR5Delivry.dart';
import "IR5Member.dart" show IR5Member;
import 'IR5PointageConso.dart' show IR5PointageConso;
import 'IR5PointagePay.dart' show IR5PointagePay;
import 'LedgerDef.dart';

// --------------------------------------------------------------------------------
part 'IR5ReqPointage.g.dart';

@JsonSerializable(explicitToJson: true)
class IR5ReqPointage {
  IR5ReqPointage({
    this.tbl,
    required this.noTbl,
    required this.ssTbl,
    this.nom,
    this.tblType,
    this.cvts,
    this.tblMode,
    this.tblIsEmport,
    this.tblDivision,
    this.action,
    this.ticketProd,
    this.addBlanco,
    this.detailsFmt,
    this.notify,
    this.memberCard,
    this.memberBarcode,
    this.member,
    this.delivry,
    this.tariff,
    this.consos,
    this.pays,
  });

  factory IR5ReqPointage.fromJson([Map<String, dynamic>? json]) =>
      _$IR5ReqPointageFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5ReqPointageToJson(this);

  final String? tbl;
  @JsonKey(defaultValue: '')
  final String noTbl;
  @JsonKey(defaultValue: '')
  final String ssTbl;
  final String? nom;
  final int? tblType;
  final int? cvts;
  final int? tblMode;
  final bool? tblIsEmport;
  final int? tblDivision;
  final HistoAction? action;
  final bool? ticketProd;
  final bool? addBlanco;
  final String? detailsFmt;
  final String? notify;
  final String? memberCard;
  final String? memberBarcode;
  final IR5Member? member;
  final IR5Delivry? delivry;
  final double? tariff;
  final List<IR5PointageConso>? consos;
  final List<IR5PointagePay>? pays;
}
