import 'package:json_annotation/json_annotation.dart';

part 'IR5Staff.g.dart';

// --------------------------------------------------------------------------------
enum StaffLevel { Staff, Manager, Boss, Commis, OnlyClock }
const Map<int, StaffLevel> StaffLevels = {
  0: StaffLevel.Staff,
  1: StaffLevel.Manager,
  2: StaffLevel.Boss,
  3: StaffLevel.Commis,
  4: StaffLevel.OnlyClock,
};
int StaffLevelToJson(StaffLevel f) {
  return StaffLevels.entries.firstWhere((element) => element.value == f).key;
}
// --------------------------------------------------------------------------------

/** PERSO aka Staffs */
@JsonSerializable()
class IR5Staff {
  const IR5Staff({
    required this.Nom,
    required this.No,
    required this.Level,
    required this.NISS,
    required this.UserLogin,
    required this.Description,
    required this.Language,
    required this.Color,
    required this.Actif,
    required this.Flags,
    required this.PointageFlags,
    required this.BOFlags,
    required this.OLAPFlags,
    required this.RptFlags,
    required this.MemberFlags,
    required this.TblModePOS,
    required this.LayoutRptOuv,
    required this.Divisions,
    required this.Stations,
    required this.Onglets,
    required this.StaffIN,
    required this.StaffOUT,
    required this.ClockIN,
    required this.ClockOUT,
    required this.SaldoOuv,
    required this.ConsoOuv,
    required this.CvtsOuv,
    required this.LstSalle,
    required this.StaffLevel,
    required this.NotBlocked,
    required this.OnlyViaBadge,
    required this.RemoteAccess,
    required this.OnlyViaTelemax,
    required this.ForceBackHome,
    required this.CanChgSalle,
    required this.GotoFirstOnglet,
    required this.StayInAccueil,
    required this.AllLastSalle,
    required this.ModePOS,
    required this.SuperStaffAutomatic,
    required this.ManagerPasDeCaisse,
    required this.StudentUseTeacherOnlyDivisions,
    required this.StudentUseTeacherOnlyStations,
    required this.StudentUseTeacherOnlyOnglets,
    required this.GotoLastTbl,
    required this.OpenStaffDoNotPrintRpt,
    required this.OpenService,
    required this.OpenServiceNoDteControl,
    required this.ClotureService,
    required this.ClotureServiceWithOpenTable,
    required this.ClotureServicePrintRpt,
    required this.ClotureStaff,
    required this.ClotureStaffWithOpenTable,
    required this.ClotureStaffDoNotPrintRpt,
    required this.ClotureStaffDoNotKeepPrestation,
    required this.ReOpenStaff,
    required this.Visu,
    required this.VisuTjsFiltree,
    required this.VisuSansTotaux,
    required this.VisuRptXorZ,
    required this.VisuShowDate,
    required this.ModifBlocage,
    required this.ModifStock,
    required this.WebView,
    required this.CanPrintFullTicket,
    required this.CanPointer,
    required this.NoBtnError,
    required this.AnnuleArticle,
    required this.AnnuleControlee,
    required this.ShowBtnRemise,
    required this.ShowBtnChgPrix,
    required this.ShowBtnOffert,
    required this.CanToggleInOut,
    required this.Training,
    required this.ForceTraining,
    required this.OnlyTraining,
    required this.CanToggleTariff,
    required this.CanAddition,
    required this.RedoAddition,
    required this.CanPointerAfterAdd,
    required this.ParamAddition,
    required this.CanCash,
    required this.ManualCashDrawer,
    required this.NoCashDrawer,
    required this.NoAutoCashDrawer,
    required this.NoAutoCashDrawerIfConso,
    required this.CanSplitMontant,
    required this.Split,
    required this.SplitAfterAddition,
    required this.TftAfterAddition,
    required this.EditStaff,
    required this.EditStaffLimited,
    required this.EditStaffSuperLimited,
    required this.EditStaffViewAll,
    required this.EditMsgAccueil,
    required this.EditPlanSalle,
    required this.EditCarte,
    required this.EditModePayement,
    required this.EditImprimantes,
    required this.EditImages,
    required this.EditEvenement,
    required this.EditReservation,
    required this.EditOthers,
    required this.DTSOps,
    required this.DTSNoArchives,
    required this.DTSNoDBOps,
    required this.DTSNoExportImportOps,
    required this.SQLEditor,
    required this.SQLBtns,
    required this.Tools,
    required this.DuplicataAdd,
    required this.TicketSimple,
    required this.RefundTicket,
    required this.AccLink,
    required this.AccLinkParams,
    required this.Billing,
    required this.RptPrint,
    required this.RptFiltered,
    required this.RptStatis,
    required this.RptListeReassor,
    required this.RptTablesOuvertes,
    required this.RptCustom1,
    required this.RptStaffOuverts,
    required this.RptCustom2,
    required this.RptRptJournee,
    required this.RptCustom3,
    required this.RptTaxRate,
    required this.RptDetailsModif,
    required this.RptCustom4,
    required this.RptFR3SummaryView,
    required this.RptPointages,
    required this.RptCustom5,
    required this.RptFR3Renta,
    required this.RptRecettes,
    required this.RptDuplicClotureStaff,
    required this.RptCustom6,
    required this.RptFR3DailyView,
    required this.RptAdditions,
    required this.RptDuplicClotureService,
    required this.RptVerifTVA,
    required this.RptExtRpts,
    required this.RptAdditionsDet,
    required this.RptSrvcZ,
    required this.RptAll,
    required this.RptExtRptsEdit,
    required this.MemberCreation,
    required this.MemberDelete,
    required this.MemberModif,
    required this.MemberModifTVA,
    required this.MemberModifCreditLimit,
    required this.MemberModifDiscount,
    required this.MemberModifAddress,
    required this.MemberModifContact,
    required this.MemberModifMemo,
    required this.MemberVoirTVA,
    required this.MemberVoirCreditLimit,
    required this.MemberVoirDiscount,
    required this.MemberVoirAddress,
    required this.MemberVoirContact,
    required this.MemberVoirMemo,
    required this.MemberShowBtn,
    required this.MemberNoSelect,
    required this.MemberSelectOnlyBarcode,
    required this.MemberEncaisseSurCpte,
    required this.MemberRechargeCpte,
    required this.MemberCaution,
    required this.MemberEncaisseSurCpteLimited,
    required this.MemberSoloCloture,
  });

  factory IR5Staff.fromJson([Map<String, dynamic>? json]) =>
      _$IR5StaffFromJson(json ?? {});
  Map<String, dynamic> toJson() => _$IR5StaffToJson(this);

  /** Staff Name */
  @JsonKey(defaultValue: '')
  final String Nom;
  @JsonKey(defaultValue: 0)
  final int No;
  @JsonKey(defaultValue: 0)
  final int /* Number | StaffLevel */ Level;

  /** Staff NISS
   * Social Security Identification Number
   * It is most of the time the National Registry Number
   */
  @JsonKey(defaultValue: '')
  final String NISS;

  /** MyRestomax User Login Name */
  @JsonKey(defaultValue: '')
  final String UserLogin;

  /** Just a free Description */
  @JsonKey(defaultValue: '')
  final String Description;

  /** Language :
   * FR : French (Default)
   * NL : Dutch
   * UK : English
   */
  @JsonKey(defaultValue: 'FR')
  final String Language;

  /** Staff personnal color. Easier to identify which Staff is logged in */
  @JsonKey(defaultValue: '')
  final String Color;
  @JsonKey(defaultValue: false)
  final bool Actif;

  /** Staff Flags
   *   Bit 00 : NotBlocked
   *   Bit 01 : OnlyViaBadge
   *   Bit 02 : RemoteAccess
   *   Bit 03 : OnlyViaTelemax
   *   Bit 04 : ForceBackHome
   *   Bit 05 : CanChgSalle
   *   Bit 06 : GotoFirstOnglet
   *   Bit 07 : StayInAccueil
   *   Bit 08 : AllLastSalle
   *   Bit 09 : ModePOS
   *   Bit 10 : Manager
   *   Bit 11 : SuperStaffAutomatic
   *   Bit 12 : ManagerPasDeCaisse
   *   Bit 13 : StudentUseTeacherOnlyDivisions
   *   Bit 14 : StudentUseTeacherOnlyStations
   *   Bit 15 : StudentUseTeacherOnlyOnglets
   *   Bit 16 : GotoLastTbl
   *   Bit 17 : OpenStaff_DoNotPrintRpt
   *   Bit 20 : OpenService
   *   Bit 21 : OpenService_NoDteControl
   *   Bit 24 : ClotureService
   *   Bit 25 : ClotureService_WithOpenTable
   *   Bit 26 : ClotureService_PrintRpt
   *   Bit 30 : ClotureStaff
   *   Bit 31 : ClotureStaff_WithOpenTable
   *   Bit 32 : ClotureStaff_DoNotPrintRpt
   *   Bit 33 : ClotureStaff_DoNotKeepPrestation
   *   Bit 34 : ReOpenStaff
   *   Bit 40 : Visu
   *   Bit 41 : VisuTjsFiltree
   *   Bit 42 : VisuSansTotaux
   *   Bit 43 : VisuRptXorZ
   *   Bit 44 : VisuShowDate
   *   Bit 50 : ModifBlocage
   *   Bit 51 : ModifStock
   *   Bit 52 : WebView
   *   Bit 60 : Boss
   */
  @JsonKey(defaultValue: 0)
  final int Flags;

  /** Staff Pointage Flags
   *   Bit 01 : CanPrintFullTicket
   *   Bit 02 : CanPointer
   *   Bit 03 : NoBtnError
   *   Bit 04 : AnnuleArticle
   *   Bit 05 : AnnuleControlee
   *   Bit 06 : ShowBtnRemise
   *   Bit 07 : ShowBtnChgPrix
   *   Bit 08 : ShowBtnOffert
   *   Bit 09 : CanToggleInOut
   *   Bit 10 : Training
   *   Bit 11 : ForceTraining
   *   Bit 12 : OnlyTraining
   *   Bit 15 : CanToggleTariff
   *   Bit 20 : CanAddition
   *   Bit 21 : RedoAddition
   *   Bit 22 : CanPointerAfterAdd
   *   Bit 23 : ParamAddition
   *   Bit 30 : CanCash
   *   Bit 31 : ManualCashDrawer
   *   Bit 32 : NoCashDrawer
   *   Bit 33 : NoAutoCashDrawer
   *   Bit 34 : NoAutoCashDrawerIfConso
   *   Bit 35 : CanSplitMontant
   *   Bit 36 : NoNegatifOnMachine
   *   Bit 40 : Split
   *   Bit 41 : SplitAfterAddition
   *   Bit 51 : TftAfterAddition
   */
  @JsonKey(defaultValue: 0)
  final int PointageFlags;

  /** Staff Backoffice Flags
   *   Bit 10 : EditStaff
   *   Bit 11 : EditStaffLimited
   *   Bit 13 : EditStaffSuperLimited
   *   Bit 14 : EditStaffViewAll
   *   Bit 20 : EditMsgAccueil
   *   Bit 21 : EditPlanSalle
   *   Bit 22 : EditCarte
   *   Bit 23 : EditModePayement
   *   Bit 24 : EditImprimantes
   *   Bit 25 : EditImages
   *   Bit 40 : EditEvenement
   *   Bit 41 : EditReservation
   *   Bit 63 : EditOthers
   */
  @JsonKey(defaultValue: 0)
  final int BOFlags;

  /** Staff Olap Flags
   *   Bit 10 : DTSOps
   *   Bit 11 : DTS_NoArchives
   *   Bit 12 : DTS_NoDBOps
   *   Bit 13 : DTS_NoExportImportOps
   *   Bit 20 : SQLEditor
   *   Bit 21 : SQLBtns
   *   Bit 28 : Tools
   *   Bit 34 : DuplicataAdd
   *   Bit 35 : TicketSimple
   *   Bit 36 : RefundTicket
   *   Bit 40 : AccLink
   *   Bit 41 : AccLinkParams
   *   Bit 50 : Billing
   */
  @JsonKey(defaultValue: 0)
  final int OLAPFlags;

  /** Staff Report Flags
   *   Bit 01 : RptPrint
   *   Bit 02 : RptFiltered
   *   Bit 10 : RptStatis
   *   Bit 11 : RptListeReassor
   *   Bit 12 : RptTablesOuvertes
   *   Bit 13 : RptCustom1
   *   Bit 16 : RptStaffOuverts
   *   Bit 17 : RptCustom2
   *   Bit 19 : RptRptJournee
   *   Bit 21 : RptCustom3
   *   Bit 22 : RptTaxRate
   *   Bit 23 : RptDetailsModif
   *   Bit 25 : RptCustom4
   *   Bit 26 : RptFR3SummaryView
   *   Bit 27 : RptPointages
   *   Bit 29 : RptCustom5
   *   Bit 30 : RptFR3Renta
   *   Bit 31 : RptRecettes
   *   Bit 32 : RptDuplicClotureStaff
   *   Bit 33 : RptCustom6
   *   Bit 34 : RptFR3DailyView
   *   Bit 35 : RptAdditions
   *   Bit 36 : RptDuplicClotureService
   *   Bit 37 : RptVerifTVA
   *   Bit 38 : RptExtRpts
   *   Bit 39 : RptAdditionsDet
   *   Bit 40 : RptSrvcZ
   *   Bit 41 : RptAll
   *   Bit 50 : RptExtRptsEdit
   */
  @JsonKey(defaultValue: 0)
  final int RptFlags;

  /** Staff Report Flags
   *   Bit 00 : MemberCreation
   *   Bit 01 : MemberDelete
   *   Bit 02 : MemberModif
   *   Bit 10 : MemberModifTVA
   *   Bit 11 : MemberModifCreditLimit
   *   Bit 13 : MemberModifDiscount
   *   Bit 14 : MemberModifAddress
   *   Bit 15 : MemberModifContact
   *   Bit 16 : MemberModifMemo
   *   Bit 30 : MemberVoirTVA
   *   Bit 31 : MemberVoirCreditLimit
   *   Bit 33 : MemberVoirDiscount
   *   Bit 34 : MemberVoirAddress
   *   Bit 35 : MemberVoirContact
   *   Bit 36 : MemberVoirMemo
   *   Bit 40 : MemberShowBtn
   *   Bit 41 : MemberNoSelect
   *   Bit 42 : MemberSelectOnlyBarcode
   *   Bit 50 : MemberEncaisseSurCpte
   *   Bit 51 : MemberRechargeCpte
   *   Bit 52 : MemberCaution
   *   Bit 53 : MemberEncaisseSurCpteLimited
   *   Bit 58 : MemberSoloCloture
   */
  @JsonKey(defaultValue: 0)
  final int MemberFlags;
  @JsonKey(defaultValue: '')
  final String TblModePOS;

  /** Print Layout */
  @JsonKey(defaultValue: 0)
  final int LayoutRptOuv;

  /** Accessible Division(s) for the Station,Staff,Article,.. */
  @JsonKey(defaultValue: '')
  final String Divisions;

  /** Accessible Station(s) for the Staff,Article,.. */
  @JsonKey(defaultValue: '')
  final String Stations;

  /** Visible Tab(s) for the Station,Staff,... */
  @JsonKey(defaultValue: '')
  final String Onglets;
  @JsonKey(defaultValue: '')
  final String StaffIN;
  @JsonKey(defaultValue: '')
  final String StaffOUT;
  @JsonKey(defaultValue: '')
  final String ClockIN;
  @JsonKey(defaultValue: '')
  final String ClockOUT;
  @JsonKey(defaultValue: 0)
  final num SaldoOuv;
  @JsonKey(defaultValue: 0)
  final num ConsoOuv;
  @JsonKey(defaultValue: 0)
  final num CvtsOuv;
  @JsonKey(defaultValue: '')
  final String LstSalle;

  /**
   *
   * Mix Flags and PointageFlags [sfOnlyClockInOut,sfCommis,sfManager,sfBoss]   */
  @JsonKey(defaultValue: 0)
  final int StaffLevel;

  @JsonKey(defaultValue: false)
  final bool NotBlocked;
  @JsonKey(defaultValue: false)
  final bool OnlyViaBadge;
  @JsonKey(defaultValue: false)
  final bool RemoteAccess;
  @JsonKey(defaultValue: false)
  final bool OnlyViaTelemax;
  @JsonKey(defaultValue: false)
  final bool ForceBackHome;
  @JsonKey(defaultValue: false)
  final bool CanChgSalle;
  @JsonKey(defaultValue: false)
  final bool GotoFirstOnglet;
  @JsonKey(defaultValue: false)
  final bool StayInAccueil;
  @JsonKey(defaultValue: false)
  final bool AllLastSalle;
  @JsonKey(defaultValue: false)
  final bool ModePOS;
  @JsonKey(defaultValue: false)
  final bool SuperStaffAutomatic;
  @JsonKey(defaultValue: false)
  final bool ManagerPasDeCaisse;
  @JsonKey(defaultValue: false)
  final bool StudentUseTeacherOnlyDivisions;
  @JsonKey(defaultValue: false)
  final bool StudentUseTeacherOnlyStations;
  @JsonKey(defaultValue: false)
  final bool StudentUseTeacherOnlyOnglets;
  @JsonKey(defaultValue: false)
  final bool GotoLastTbl;
  @JsonKey(defaultValue: false)
  final bool OpenStaffDoNotPrintRpt;
  @JsonKey(defaultValue: false)
  final bool OpenService;
  @JsonKey(defaultValue: false)
  final bool OpenServiceNoDteControl;
  @JsonKey(defaultValue: false)
  final bool ClotureService;
  @JsonKey(defaultValue: false)
  final bool ClotureServiceWithOpenTable;
  @JsonKey(defaultValue: false)
  final bool ClotureServicePrintRpt;
  @JsonKey(defaultValue: false)
  final bool ClotureStaff;
  @JsonKey(defaultValue: false)
  final bool ClotureStaffWithOpenTable;
  @JsonKey(defaultValue: false)
  final bool ClotureStaffDoNotPrintRpt;
  @JsonKey(defaultValue: false)
  final bool ClotureStaffDoNotKeepPrestation;
  @JsonKey(defaultValue: false)
  final bool ReOpenStaff;
  @JsonKey(defaultValue: false)
  final bool Visu;
  @JsonKey(defaultValue: false)
  final bool VisuTjsFiltree;
  @JsonKey(defaultValue: false)
  final bool VisuSansTotaux;
  @JsonKey(defaultValue: false)
  final bool VisuRptXorZ;
  @JsonKey(defaultValue: false)
  final bool VisuShowDate;
  @JsonKey(defaultValue: false)
  final bool ModifBlocage;
  @JsonKey(defaultValue: false)
  final bool ModifStock;
  @JsonKey(defaultValue: false)
  final bool WebView;
  @JsonKey(defaultValue: false)
  final bool CanPrintFullTicket;
  @JsonKey(defaultValue: false)
  final bool CanPointer;
  @JsonKey(defaultValue: false)
  final bool NoBtnError;
  @JsonKey(defaultValue: false)
  final bool AnnuleArticle;
  @JsonKey(defaultValue: false)
  final bool AnnuleControlee;
  @JsonKey(defaultValue: false)
  final bool ShowBtnRemise;
  @JsonKey(defaultValue: false)
  final bool ShowBtnChgPrix;
  @JsonKey(defaultValue: false)
  final bool ShowBtnOffert;
  @JsonKey(defaultValue: false)
  final bool CanToggleInOut;
  @JsonKey(defaultValue: false)
  final bool Training;
  @JsonKey(defaultValue: false)
  final bool ForceTraining;
  @JsonKey(defaultValue: false)
  final bool OnlyTraining;
  @JsonKey(defaultValue: false)
  final bool CanToggleTariff;
  @JsonKey(defaultValue: false)
  final bool CanAddition;
  @JsonKey(defaultValue: false)
  final bool RedoAddition;
  @JsonKey(defaultValue: false)
  final bool CanPointerAfterAdd;
  @JsonKey(defaultValue: false)
  final bool ParamAddition;
  @JsonKey(defaultValue: false)
  final bool CanCash;
  @JsonKey(defaultValue: false)
  final bool ManualCashDrawer;
  @JsonKey(defaultValue: false)
  final bool NoCashDrawer;
  @JsonKey(defaultValue: false)
  final bool NoAutoCashDrawer;
  @JsonKey(defaultValue: false)
  final bool NoAutoCashDrawerIfConso;
  @JsonKey(defaultValue: false)
  final bool CanSplitMontant;
  @JsonKey(defaultValue: false)
  final bool Split;
  @JsonKey(defaultValue: false)
  final bool SplitAfterAddition;
  @JsonKey(defaultValue: false)
  final bool TftAfterAddition;
  @JsonKey(defaultValue: false)
  final bool EditStaff;
  @JsonKey(defaultValue: false)
  final bool EditStaffLimited;
  @JsonKey(defaultValue: false)
  final bool EditStaffSuperLimited;
  @JsonKey(defaultValue: false)
  final bool EditStaffViewAll;
  @JsonKey(defaultValue: false)
  final bool EditMsgAccueil;
  @JsonKey(defaultValue: false)
  final bool EditPlanSalle;
  @JsonKey(defaultValue: false)
  final bool EditCarte;
  @JsonKey(defaultValue: false)
  final bool EditModePayement;
  @JsonKey(defaultValue: false)
  final bool EditImprimantes;
  @JsonKey(defaultValue: false)
  final bool EditImages;
  @JsonKey(defaultValue: false)
  final bool EditEvenement;
  @JsonKey(defaultValue: false)
  final bool EditReservation;
  @JsonKey(defaultValue: false)
  final bool EditOthers;
  @JsonKey(defaultValue: false)
  final bool DTSOps;
  @JsonKey(defaultValue: false)
  final bool DTSNoArchives;
  @JsonKey(defaultValue: false)
  final bool DTSNoDBOps;
  @JsonKey(defaultValue: false)
  final bool DTSNoExportImportOps;
  @JsonKey(defaultValue: false)
  final bool SQLEditor;
  @JsonKey(defaultValue: false)
  final bool SQLBtns;
  @JsonKey(defaultValue: false)
  final bool Tools;
  @JsonKey(defaultValue: false)
  final bool DuplicataAdd;
  @JsonKey(defaultValue: false)
  final bool TicketSimple;
  @JsonKey(defaultValue: false)
  final bool RefundTicket;
  @JsonKey(defaultValue: false)
  final bool AccLink;
  @JsonKey(defaultValue: false)
  final bool AccLinkParams;
  @JsonKey(defaultValue: false)
  final bool Billing;
  @JsonKey(defaultValue: false)
  final bool RptPrint;
  @JsonKey(defaultValue: false)
  final bool RptFiltered;
  @JsonKey(defaultValue: false)
  final bool RptStatis;
  @JsonKey(defaultValue: false)
  final bool RptListeReassor;
  @JsonKey(defaultValue: false)
  final bool RptTablesOuvertes;
  @JsonKey(defaultValue: false)
  final bool RptCustom1;
  @JsonKey(defaultValue: false)
  final bool RptStaffOuverts;
  @JsonKey(defaultValue: false)
  final bool RptCustom2;
  @JsonKey(defaultValue: false)
  final bool RptRptJournee;
  @JsonKey(defaultValue: false)
  final bool RptCustom3;
  @JsonKey(defaultValue: false)
  final bool RptTaxRate;
  @JsonKey(defaultValue: false)
  final bool RptDetailsModif;
  @JsonKey(defaultValue: false)
  final bool RptCustom4;
  @JsonKey(defaultValue: false)
  final bool RptFR3SummaryView;
  @JsonKey(defaultValue: false)
  final bool RptPointages;
  @JsonKey(defaultValue: false)
  final bool RptCustom5;
  @JsonKey(defaultValue: false)
  final bool RptFR3Renta;
  @JsonKey(defaultValue: false)
  final bool RptRecettes;
  @JsonKey(defaultValue: false)
  final bool RptDuplicClotureStaff;
  @JsonKey(defaultValue: false)
  final bool RptCustom6;
  @JsonKey(defaultValue: false)
  final bool RptFR3DailyView;
  @JsonKey(defaultValue: false)
  final bool RptAdditions;
  @JsonKey(defaultValue: false)
  final bool RptDuplicClotureService;
  @JsonKey(defaultValue: false)
  final bool RptVerifTVA;
  @JsonKey(defaultValue: false)
  final bool RptExtRpts;
  @JsonKey(defaultValue: false)
  final bool RptAdditionsDet;
  @JsonKey(defaultValue: false)
  final bool RptSrvcZ;
  @JsonKey(defaultValue: false)
  final bool RptAll;
  @JsonKey(defaultValue: false)
  final bool RptExtRptsEdit;
  @JsonKey(defaultValue: false)
  final bool MemberCreation;
  @JsonKey(defaultValue: false)
  final bool MemberDelete;
  @JsonKey(defaultValue: false)
  final bool MemberModif;
  @JsonKey(defaultValue: false)
  final bool MemberModifTVA;
  @JsonKey(defaultValue: false)
  final bool MemberModifCreditLimit;
  @JsonKey(defaultValue: false)
  final bool MemberModifDiscount;
  @JsonKey(defaultValue: false)
  final bool MemberModifAddress;
  @JsonKey(defaultValue: false)
  final bool MemberModifContact;
  @JsonKey(defaultValue: false)
  final bool MemberModifMemo;
  @JsonKey(defaultValue: false)
  final bool MemberVoirTVA;
  @JsonKey(defaultValue: false)
  final bool MemberVoirCreditLimit;
  @JsonKey(defaultValue: false)
  final bool MemberVoirDiscount;
  @JsonKey(defaultValue: false)
  final bool MemberVoirAddress;
  @JsonKey(defaultValue: false)
  final bool MemberVoirContact;
  @JsonKey(defaultValue: false)
  final bool MemberVoirMemo;
  @JsonKey(defaultValue: false)
  final bool MemberShowBtn;
  @JsonKey(defaultValue: false)
  final bool MemberNoSelect;
  @JsonKey(defaultValue: false)
  final bool MemberSelectOnlyBarcode;
  @JsonKey(defaultValue: false)
  final bool MemberEncaisseSurCpte;
  @JsonKey(defaultValue: false)
  final bool MemberRechargeCpte;
  @JsonKey(defaultValue: false)
  final bool MemberCaution;
  @JsonKey(defaultValue: false)
  final bool MemberEncaisseSurCpteLimited;
  @JsonKey(defaultValue: false)
  final bool MemberSoloCloture;
}
